      subroutine cyax ( n, alpha, x, incx, y, incy )
c#######################################################################
c
c Compute Y = alpha * X
c
c Last modified:   May 7, 1992
c
c#######################################################################
c Last entry to update in Y
      integer n
c Scalar multiplier
      complex alpha
c Vector multiplicand
      complex x(*)
c Increment for X vector
      integer incx
c Result vector
      complex y(*)
c Increment for Y vector
      integer incy
c Local (temporary) variable
      complex ax
c#######################################################################
c
c incx == 0 and incy == 1
c
c#######################################################################
      if(incx.eq.0.and.incy.eq.1) then 
          ax = alpha * x(1)
          y(1:n) = ax
c#######################################################################
c
c incx == 1 and incy == 1
c
c#######################################################################
      elseif(incx.eq.1.and.incy.eq.1) then 
          if(alpha.eq.1.0) then 
              y(1:n) = x(1:n)
          else
              y(1:n) = alpha * x(1:n)
          endif
c#######################################################################
c
c incx == 1 and incy != 1
c
c#######################################################################
      elseif(incx.eq.1) then 
          if(alpha.eq.1.0) then 
              y(1:n:incy) = x(1:n)
          else
              y(1:n:incy) = alpha * x(1:n)
          endif
c#######################################################################
c
c incx != 1 and incy == 1
c
c#######################################################################
      elseif(incy.eq.1) then 
          if(alpha.eq.1.0) then 
              y(1:n) = x(1:n:incx)
          else
              y(1:n) = alpha * x(1:n:incx)
          endif
c#######################################################################
c
c incx != 1 and incy != 1
c
c#######################################################################
      else
          if(alpha.eq.1.0) then 
              y(1:n:incy) = x(1:n:incx)
          else
              y(1:n:incy) = alpha * x(1:n:incx)
          endif
      endif
      return
      end
      subroutine cgeadd ( a, lda, forma, b, ldb, formb, c, ldc, m, n )
c#######################################################################
c
c Compute C = op(A) + op(B), where
c
c                 { M,           if formm == 'N'
c         op(M) = {
c                 { M transpose, if formm == 'T'
c
c Last modified:   May 7, 1992
c
c#######################################################################
c Leading dimension of matrix A
      integer lda
c Coefficients of A
      complex a(lda,*)
c 'N' or 'T' for op(A)
      character*(*) forma
c Leading dimension of matrix B
      integer ldb
c Coefficients of B
      complex b(ldb,*)
c 'N' or 'T' for op(B)
      character*(*) formb
c Leading dimension of matrix C
      integer ldc
c Result matrix
      complex c(ldc,*)
c Rows of C
      integer m
c Columns of C
      integer n
      integer j
c First char of forma and formb
      character*1 fma, fmb
c#######################################################################
c
c Translate the formulation of A and B
c
c#######################################################################
      fma = forma(1:1)
      fmb = formb(1:1)
      if(fma.eq.'n') then 
          fma = 'N'
      elseif(fma.eq.'t') then 
          fma = 'T'
      endif
      if(fmb.eq.'n') then 
          fmb = 'N'
      elseif(fmb.eq.'t') then 
          fmb = 'T'
c#######################################################################
c
c C = A + B
c
c#######################################################################
      endif
      if(fma.eq.'N'.and.fmb.eq.'N') then 
          c(1:m,1:n) = a(1:m,1:n) + b(1:m,1:n)
c#######################################################################
c
c      T
c C = A  + B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'N') then 
          do 2000  j = 1,n
              c(1:m,j) = a(j,1:m) + b(1:m,j)
2000      continue
c#######################################################################
c
c          T
c C = A + B
c
c#######################################################################
      elseif(fma.eq.'N'.and.fmb.eq.'T') then 
          do 2002  j = 1,n
              c(1:m,j) = a(1:m,j) + b(j,1:m)
2002      continue
c#######################################################################
c
c      T    T
c C = A  + B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'T') then 
          do 2004  j = 1,m
              c(j,1:n) = a(1:n,j) + b(1:n,j)
2004      continue
      endif
      return
      end
      subroutine cgesub ( a, lda, forma, b, ldb, formb, c, ldc, m, n )
c#######################################################################
c
c Compute C = op(A) - op(B), where
c
c                 { M,           if formm == 'N'
c         op(M) = {
c                 { M transpose, if formm == 'T'
c
c Last modified:   May 7, 1992
c
c#######################################################################
c Leading dimension of matrix A
      integer lda
c Coefficients of A
      complex a(lda,*)
c 'N' or 'T' for op(A)
      character*(*) forma
c Leading dimension of matrix B
      integer ldb
c Coefficients of B
      complex b(ldb,*)
c 'N' or 'T' for op(B)
      character*(*) formb
c Leading dimension of matrix C
      integer ldc
c Result matrix
      complex c(ldc,*)
c Rows of C
      integer m
c Columns of C
      integer n
      integer j
c First char of forma and formb
      character*1 fma, fmb
c#######################################################################
c
c Translate the formulation of A and B
c
c#######################################################################
      fma = forma(1:1)
      fmb = formb(1:1)
      if(fma.eq.'n') then 
          fma = 'N'
      elseif(fma.eq.'t') then 
          fma = 'T'
      endif
      if(fmb.eq.'n') then 
          fmb = 'N'
      elseif(fmb.eq.'t') then 
          fmb = 'T'
c#######################################################################
c
c C = A - B
c
c#######################################################################
      endif
      if(fma.eq.'N'.and.fmb.eq.'N') then 
          c(1:m,1:n) = a(1:m,1:n) - b(1:m,1:n)
c#######################################################################
c
c      T
c C = A  - B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'N') then 
          do 2006  j = 1,n
              c(1:m,j) = a(j,1:m) - b(1:m,j)
2006      continue
c#######################################################################
c
c          T
c C = A - B
c
c#######################################################################
      elseif(fma.eq.'N'.and.fmb.eq.'T') then 
          do 2008  j = 1,n
              c(1:m,j) = a(1:m,j) - b(j,1:m)
2008      continue
c#######################################################################
c
c      T    T
c C = A  - B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'T') then 
          do 2010  j = 1,m
              c(j,1:n) = a(1:n,j) - b(1:n,j)
2010      continue
      endif
      return
      end
      subroutine syax ( n, alpha, x, incx, y, incy )
c#######################################################################
c
c Compute Y = alpha * X
c
c Last modified:   May 7, 1992
c
c#######################################################################
c Last entry to update in Y
      integer n
c Scalar multiplier
      real alpha
c Vector multiplicand
      real x(*)
c Increment for X vector
      integer incx
c Result vector
      real y(*)
c Increment for Y vector
      integer incy
c Local (temporary) variable
      real ax
c#######################################################################
c
c incx == 0 and incy == 1
c
c#######################################################################
      if(incx.eq.0.and.incy.eq.1) then 
          ax = alpha * x(1)
          y(1:n) = ax
c#######################################################################
c
c incx == 1 and incy == 1
c
c#######################################################################
      elseif(incx.eq.1.and.incy.eq.1) then 
          if(alpha.eq.1.0) then 
              y(1:n) = x(1:n)
          else
              y(1:n) = alpha * x(1:n)
          endif
c#######################################################################
c
c incx == 1 and incy != 1
c
c#######################################################################
      elseif(incx.eq.1) then 
          if(alpha.eq.1.0) then 
              y(1:n:incy) = x(1:n)
          else
              y(1:n:incy) = alpha * x(1:n)
          endif
c#######################################################################
c
c incx != 1 and incy == 1
c
c#######################################################################
      elseif(incy.eq.1) then 
          if(alpha.eq.1.0) then 
              y(1:n) = x(1:n:incx)
          else
              y(1:n) = alpha * x(1:n:incx)
          endif
c#######################################################################
c
c incx != 1 and incy != 1
c
c#######################################################################
      else
          if(alpha.eq.1.0) then 
              y(1:n:incy) = x(1:n:incx)
          else
              y(1:n:incy) = alpha * x(1:n:incx)
          endif
      endif
      return
      end
      subroutine sgeadd ( a, lda, forma, b, ldb, formb, c, ldc, m, n )
c#######################################################################
c
c Compute C = op(A) + op(B), where
c
c                 { M,           if formm == 'N'
c         op(M) = {
c                 { M transpose, if formm == 'T'
c
c Last modified:   May 7, 1992
c
c#######################################################################
c Leading dimension of matrix A
      integer lda
c Coefficients of A
      real a(lda,*)
c 'N' or 'T' for op(A)
      character*(*) forma
c Leading dimension of matrix B
      integer ldb
c Coefficients of B
      real b(ldb,*)
c 'N' or 'T' for op(B)
      character*(*) formb
c Leading dimension of matrix C
      integer ldc
c Result matrix
      real c(ldc,*)
c Rows of C
      integer m
c Columns of C
      integer n
      integer j
c First char of forma and formb
      character*1 fma, fmb
c#######################################################################
c
c Translate the formulation of A and B
c
c#######################################################################
      fma = forma(1:1)
      fmb = formb(1:1)
      if(fma.eq.'n') then 
          fma = 'N'
      elseif(fma.eq.'t') then 
          fma = 'T'
      endif
      if(fmb.eq.'n') then 
          fmb = 'N'
      elseif(fmb.eq.'t') then 
          fmb = 'T'
c#######################################################################
c
c C = A + B
c
c#######################################################################
      endif
      if(fma.eq.'N'.and.fmb.eq.'N') then 
          c(1:m,1:n) = a(1:m,1:n) + b(1:m,1:n)
c#######################################################################
c
c      T
c C = A  + B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'N') then 
          do 2000  j = 1,n
              c(1:m,j) = a(j,1:m) + b(1:m,j)
2000      continue
c#######################################################################
c
c          T
c C = A + B
c
c#######################################################################
      elseif(fma.eq.'N'.and.fmb.eq.'T') then 
          do 2002  j = 1,n
              c(1:m,j) = a(1:m,j) + b(j,1:m)
2002      continue
c#######################################################################
c
c      T    T
c C = A  + B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'T') then 
          do 2004  j = 1,m
              c(j,1:n) = a(1:n,j) + b(1:n,j)
2004      continue
      endif
      return
      end
      subroutine sgesub ( a, lda, forma, b, ldb, formb, c, ldc, m, n )
c#######################################################################
c
c Compute C = op(A) - op(B), where
c
c                 { M,           if formm == 'N'
c         op(M) = {
c                 { M transpose, if formm == 'T'
c
c Last modified:   May 7, 1992
c
c#######################################################################
c Leading dimension of matrix A
      integer lda
c Coefficients of A
      real a(lda,*)
c 'N' or 'T' for op(A)
      character*(*) forma
c Leading dimension of matrix B
      integer ldb
c Coefficients of B
      real b(ldb,*)
c 'N' or 'T' for op(B)
      character*(*) formb
c Leading dimension of matrix C
      integer ldc
c Result matrix
      real c(ldc,*)
c Rows of C
      integer m
c Columns of C
      integer n
      integer j
c First char of forma and formb
      character*1 fma, fmb
c#######################################################################
c
c Translate the formulation of A and B
c
c#######################################################################
      fma = forma(1:1)
      fmb = formb(1:1)
      if(fma.eq.'n') then 
          fma = 'N'
      elseif(fma.eq.'t') then 
          fma = 'T'
      endif
      if(fmb.eq.'n') then 
          fmb = 'N'
      elseif(fmb.eq.'t') then 
          fmb = 'T'
c#######################################################################
c
c C = A - B
c
c#######################################################################
      endif
      if(fma.eq.'N'.and.fmb.eq.'N') then 
          c(1:m,1:n) = a(1:m,1:n) - b(1:m,1:n)
c#######################################################################
c
c      T
c C = A  - B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'N') then 
          do 2006  j = 1,n
              c(1:m,j) = a(j,1:m) - b(1:m,j)
2006      continue
c#######################################################################
c
c          T
c C = A - B
c
c#######################################################################
      elseif(fma.eq.'N'.and.fmb.eq.'T') then 
          do 2008  j = 1,n
              c(1:m,j) = a(1:m,j) - b(j,1:m)
2008      continue
c#######################################################################
c
c      T    T
c C = A  - B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'T') then 
          do 2010  j = 1,m
              c(j,1:n) = a(1:n,j) - b(1:n,j)
2010      continue
      endif
      return
      end
